"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceAccount = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront Service Account Resource. This allows service accounts to be created, updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const basic = new wavefront.ServiceAccount("basic", {
 *     identifier: "sa::tftesting",
 *     active: true,
 * });
 * ```
 *
 * ## Import
 *
 * Service accounts can be imported by using `identifier`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/serviceAccount:ServiceAccount basic sa::tftesting
 * ```
 */
class ServiceAccount extends pulumi.CustomResource {
    /**
     * Get an existing ServiceAccount resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ServiceAccount(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ServiceAccount.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ServiceAccount.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["active"] = state ? state.active : undefined;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["identifier"] = state ? state.identifier : undefined;
            resourceInputs["ingestionPolicy"] = state ? state.ingestionPolicy : undefined;
            resourceInputs["permissions"] = state ? state.permissions : undefined;
            resourceInputs["userGroups"] = state ? state.userGroups : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.identifier === undefined) && !opts.urn) {
                throw new Error("Missing required property 'identifier'");
            }
            resourceInputs["active"] = args ? args.active : undefined;
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["identifier"] = args ? args.identifier : undefined;
            resourceInputs["ingestionPolicy"] = args ? args.ingestionPolicy : undefined;
            resourceInputs["permissions"] = args ? args.permissions : undefined;
            resourceInputs["userGroups"] = args ? args.userGroups : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(ServiceAccount.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ServiceAccount = ServiceAccount;
/** @internal */
ServiceAccount.__pulumiType = 'wavefront:index/serviceAccount:ServiceAccount';
//# sourceMappingURL=serviceAccount.js.map